
this.Webvisum = this.Webvisum || {

  getWebvisumService: function(){
    return Components.classes["@webvisum/webvisumservice;1"].getService().wrappedJSObject;
  },
  
  getGlobalWebvisum: function(){
    return Webvisum.getWebvisumService().global;
  },
  
  /*
  * Inspired by prototypal inheritance by www.crockford.com newObject =
  * Webvisum.beget(oldObject);
  */ 
  beget: function (o) {
    function F() {
      this.super = this.__proto__;
      this.include = function(aModule){
        for (var m in aModule) this[m]=aModule[m]; 
        return this;
      }
      this.superMethod = function( aMethodName, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9){
        return this.super[aMethodName].call(this, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9)
      }
    }
    F.prototype = o;
    return new F();
  }
};

Webvisum.Common = {
    
    LOGGING:false,
    
    objMethod:function(anObj, aMethod){                                                                                                                              
        return (function(arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8){
            if (!anObj[aMethod]) throw "Object "+anObj+" has no function "+aMethod;
            return anObj[aMethod](arg1,arg2,arg3,arg4,arg5,arg6,arg7,arg8)
            })                                                                                                        
    }, 
    
    
    getLocale:function(){
        const p = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("general.useragent.");
        var locale = null;
        try {
            locale = p.getComplexValue("locale", Components.interfaces.nsIPrefLocalizedString).data
        }
        catch (e){
            locale = p.getCharPref("locale"); 
        }
        return locale.slice(0, 2);
    },
    
    
    
     _log_:function(aMsg){
      dump(aMsg+"\n");
      var cs = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService);
      if (aMsg['warningFlag']) 
        cs.logMessage(aMsg);
      else
        cs.logStringMessage('[ws] '+aMsg);
    }, 
    
    log:function(aMsg){
        if (this.LOGGING) {
            aMsg = this.fdate()+" "+aMsg;
            this._log_(aMsg);
        }
    }, 
    
    
    logErr:function(aMsg, aDetails){
      aMsg = this.fdate()+" "+aMsg;
      var msg = Components.classes['@mozilla.org/scripterror;1'].createInstance(Components.interfaces.nsIScriptError);
      msg.init('[ws] '+aMsg, null, aDetails, 0,0,Components.interfaces.nsIScriptError.errorFlag , 'webvisum');
      this._log_(msg);
    }, 
    logWrn:function(aMsg, aDetails){
      aMsg = this.fdate()+" "+aMsg;
      var msg = Components.classes['@mozilla.org/scripterror;1'].createInstance(Components.interfaces.nsIScriptError);
      msg.init('[ws] '+aMsg, null, aDetails, 0,0,Components.interfaces.nsIScriptError.warningFlag , 'webvisum');
      this._log_(msg);
    }, 
    
    // returns {usernme: , :password, :checkbox}
    promptUsernamePassword:function(aTitle, aText, aCheckboxMsg, aValues){
        const promptService = Components.classes['@mozilla.org/embedcomp/prompt-service;1']
            .createInstance(Components.interfaces.nsIPromptService);
        var u = {};
        var p = {};
        var ch = {};
        if(aValues){
            u.value = aValues['username'];
            p.value = aValues['password'];
            ch.value = aValues['checkbox'];
        }
        return promptService.promptUsernameAndPassword(window, aTitle, aText, u, p, aCheckboxMsg, ch )
            ? {
                username: u.value,
                password: p.value,
                checkbox: ch.value
              }
            : null
    },
    
    alertEx:function(aMsg, aTitle){
        const promptService = Components.classes['@mozilla.org/embedcomp/prompt-service;1']
            .createInstance(Components.interfaces.nsIPromptService);
        promptService.alert(window, (aTitle || 'Information'), aMsg);
    },
    
    tag:function(aTagName, aXmlDoc /* optional */){
        if (!aXmlDoc) aXmlDoc = document;
        var col = aXmlDoc.getElementsByTagName(aTagName)
        return col.length > 0 ? col[0] : null;    
    },
    
    tags:function(aTagName, aXmlDoc /* optional */){
        if (!aXmlDoc) aXmlDoc = document;
        var col = aXmlDoc.getElementsByTagName(aTagName)
        return col;    
    // return col.length > 0 ? col : null;
    },
    
    xpath:function(anXPath, optContext){
        if (!optContext) optContext = document;
        const doc = optContext.ownerDocument || optContext;
        const nodesSnapshot = doc.evaluate(anXPath, optContext, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null );
        var ary = [];
        for ( var i=0 ; i < nodesSnapshot.snapshotLength; i++ ){
          ary.push( nodesSnapshot.snapshotItem(i) );      
        }
        return ary
    },
    
    idd:function(anId, aXmlDoc /* optional */){
        if (!aXmlDoc) aXmlDoc = document;
        if (!aXmlDoc.getElementById) aXmlDoc = aXmlDoc.ownerDocument; //if it is not a document but element
        return aXmlDoc.getElementById(anId);    
    },
    
    unwrap:function(anObject){
        var o = anObject && anObject.wrappedJSObject;
        return o ? o : anObject;
    },
    
    // clone given object
    clone:function (anObject, deep) {
        if(!anObject) return null;
        var objectClone = new anObject.constructor();
        for (var property in anObject)
            if (!deep) objectClone[property] = anObject[property];
            else if (typeof anObject[property] == 'object')
                    objectClone[property] = this.clone(anObject[property], deep);
                else
                    objectClone[property] = anObject[property];
        return objectClone;
    },
    
    fork:function(aFunction, aDelay){
        if (!aDelay) aDelay = 0;
        setTimeout(aFunction, aDelay);
    },
    
    toDate:function (aSecondsOrMs) {
        //we assume seconds for the project
        return new Date(1000*aSecondsOrMs)
        
    },

    fdate:function (aDate) {
        aDate = aDate || new Date();
        return aDate.getFullYear()+"-"+(aDate.getMonth()+1)+"-"+aDate.getDate()+" "+aDate.getHours()+":"+aDate.getMinutes()+":"+aDate.getSeconds()        
    },
    
    trim:function(aString){                                                                                                      
        return aString.replace(/^\s*|\s*$/g,'');                                                                                 
    },
    //http://jsfromhell.com/string/capitalize
    capitalize:function(s){ 
        return s.replace(/\w+/g, function(a){ return a.charAt(0).toUpperCase() + a.substr(1).toLowerCase(); })
    },
    dumpObj:function(anObj, aDelimiter){
        if(!anObj) return null;
        if(!aDelimiter) aDelimiter=', ';
        var str='{';
        for(var name in anObj){
            if(str.length>1)str+=aDelimiter;
            var val=anObj[name] ? anObj[name].toString() : 'null';
            str+="'"+name+"':"+val;
        }
        str+='}';
        return str
    },
    printObj:function(obj){
        var str = obj + "\n";
        for (a in obj) {
            str += a + ": " + obj[a] + "\n";
        }
        this.log(str);
    },
    
    merge:function(one, another){
        if (another) 
            for (var m in another) one[m]=another[m]; 
        return one;
    }
}
