// REQIURES: common.js ????



Webvisum.Monkey = {
    analyze:function (aDocument) {
        this.doc = aDocument;
        this.location = aDocument.location;
        this.domain = this.extractDomainFromUrl(this.location);
        this.referrer = aDocument.referrer;
        this.title = aDocument.title;
        this.links = Webvisum.Common.tags('a', aDocument); 
        this.images = Webvisum.Common.tags('img', aDocument);
        this.imagesbg = null;
        this.captchas = this.findCaptchas(this.doc, webvisum.getCaptchaRules());
        Webvisum.Common.log(this);
        return this;
    },    
    toString:function () {
        return "Analyze: '"+this.title+"' "+this.location+" ("+this.domain+")"
         +" {ref:'"+this.referrer +"', links:" +this.links.length+", images:"+this.images.length+"}" ; 
    },
    
    promptEditObject:function (aWebvisumObject, optMessage) {        
        const name = aWebvisumObject.getLocalizedName();
        const title = 'Tag '+name;
        var question = 'Give a label to '+name;
        if (optMessage) question+=" "+optMessage;
        question+=" '"+aWebvisumObject.id+"':"
        var defaultValue = aWebvisumObject.label ? aWebvisumObject.label : '';
        var reply = prompt(question, defaultValue, title);
        if (reply) {
            return aWebvisumObject.editLabel(reply);
        }
        return false;
    },
    guessMimeType : function(aUrl) {
        //TODO: find a more proper way (mozilla internals)
        if (aUrl.match(/\.png/i))
            return "image/png";
        if (aUrl.match(/\.gif/i))
            return "image/gif";
        if (aUrl.match(/\.(jpg|jpeg|jpe)/i))
            return "image/jpeg";
        return "image/???";
    },
    copyToClipboard:function (aText) {
        const clipboard = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
            .getService(Components.interfaces.nsIClipboardHelper);
        clipboard.copyString(aText);        
    },
    findOuterAnchor:function (anElement) {
        var parent = anElement;
        while (parent!=null && parent!=parent.parentNode){
            if (parent instanceof Components.interfaces.nsIDOMHTMLAnchorElement 
                || parent instanceof Components.interfaces.nsIDOMHTMLAreaElement) return parent; 
            parent = parent.parentNode;
        }
        return null;
    },
    // http://xxx.fff.com:8000/ididsdfs?erwer=erwer -> xxx.fff.com:8000
    // http://xxx.fff.com -> xxx.fff.com
    // file://home/tmp/xx - > file://home/tmp/xx
    // ? -> ?
    extractDomainFromUrl:function(aLocationOrUrl){
        try {
            var host = aLocationOrUrl.host;            
        }
        catch(e){
            Webvisum.Common.log('domain extraction failed: not proper uri '+aLocationOrUrl);
            return aLocationOrUrl
        }
        if (!host){
            //if not location
            var m = aLocationOrUrl.toString().match(/https?:\/\/(.*?)([\/\:\;]|$)/);
            host = m && m[1].toLowerCase() || aLocationOrUrl.toString().toLowerCase();
        }
        //strip leading 'www.'
        host = host.replace(/^www\./,'');
        //strip trailing port
        host = host.replace(/\:\d+/,'')
        return host;
    },
    extractCredentials:function (aDocument) {
        const f = aDocument.forms['credentials'];
        if (f) {
            var creds = {};
            creds['username']= f.usr && f.usr.value;
            creds['password']= f.pwd && f.pwd.value;
            return creds;
        }
        return null
    },
    collectDocuments:function(aRootDoc, anOutputDocs) {
        if (!anOutputDocs) anOutputDocs = [];
        anOutputDocs.push( Webvisum.Common.unwrap(aRootDoc) );
        const concat = function(aCollection, aTargetArray){
            for (var i=0; i<aCollection.length; i++) aTargetArray.push( aCollection.item(i) );
            return aTargetArray;
        }
        var immediateFrames = [];
        concat( Webvisum.Common.tags("frame", aRootDoc), immediateFrames );
        concat( Webvisum.Common.tags("iframe", aRootDoc), immediateFrames );
    
        
        for (var i=0; i<immediateFrames.length; i++) {
            // Webvisum.Common.log('DBG: RECURSING: '+immediateFrames[i]);
            var frameDocument = immediateFrames[i].contentDocument;
            if (frameDocument) 
                this.collectDocuments(frameDocument, anOutputDocs);
        }
        return anOutputDocs
    },
    findSensitiveSelects:function (aDocument) {
        return Webvisum.Common.xpath('//select[@onchange]', aDocument);
    },
    fixSensitiveSelect:function (aSelectElement, optLabel) {
        if (aSelectElement.style.display=='none') return;
        const onchange = aSelectElement.getAttribute('onchange');
        aSelectElement.removeAttribute('onchange');
        Webvisum.Common.log('onchange:'+onchange);
        const doc = aSelectElement.ownerDocument;
        const win = doc.defaultView;
        //construct button
        var button = doc.createElement('button');
        button.setAttribute('type', 'button');
        button.appendChild(doc.createTextNode(optLabel || 'select'));
        button.setAttribute('class','webvisum');
        button.style['border']='solid 2px yellow'
        
        
        var wrapperScript = 'try { var ns = {func: function(event){'+onchange+'}};'
        wrapperScript += ' var select = this.previousSibling;'
        wrapperScript += ' var event = document.createEvent("Event"); event.initEvent("change", true, false); select.dispatchEvent(event);'
        wrapperScript += ' ns.func.call(select, event); } catch(e){alert(e)}'

        button.setAttribute('onclick', wrapperScript);
        
        var parent = aSelectElement.parentNode;
        var sibling = aSelectElement.nextSibling;
        if (aSelectElement==sibling) {
            parent.appendChild(button);           
        }
        else {
            parent.insertBefore(button, sibling);
        }    
        return button
    },
    fetchCacheEntry:function (aUrl) {
        // If the URL is not entirely generated
        var cacheEntry = null;
        if(aUrl.indexOf("wyciwyg://") != 0) {
            var cacheService = Components.classes["@mozilla.org/network/cache-service;1"]
                .getService(Components.interfaces.nsICacheService);
            const READACCESS   = Components.interfaces.nsICache.ACCESS_READ;
    
            try {
                var cacheSession = cacheService.createSession("HTTP", 0, true);
                cacheSession.doomEntriesIfExpired = false;
                cacheEntry = cacheSession.openCacheEntry(aUrl, READACCESS, false);
            }
            catch(e1) {
                try {
                    var cacheSession = cacheService.createSession("FTP", 0, true);
                    cacheSession.doomEntriesIfExpired = false;
                    cacheEntry = cacheSession.openCacheEntry(aUrl, READACCESS, false);
                }
                catch(e2) {
                    cacheEntry = null;
                }
            }
        }
        return cacheEntry
    },
    fetchCacheData:function (aUrl) {
        // based on WebDeveloper code
        var entry = this.fetchCacheEntry(aUrl);
        if (entry){
            var encoding = null;
            var responseHeaders = null;

            // Try to get the cache encoding
            try {
                // Specific case-sensitive required
                encoding = entry.getMetaDataElement("request-Accept-Encoding");
            }
            catch(exception) {
                // Try to get the response headers
                try {
                    // Specific case-sensitive required
                    responseHeaders = entry.getMetaDataElement("response-head");
                }
                catch(exception) {}
            }

            // If the cache is not GZIP encoded
            if((!encoding || encoding.indexOf("gzip") == -1) 
                    && (!responseHeaders || (responseHeaders.indexOf("Content-Encoding: deflate") == -1 && responseHeaders.indexOf("Content-Encoding: gzip") == -1))) {
                var inputStream      = entry.openInputStream(0);
                // adjusted to work in binary
                var bis= Components.classes["@mozilla.org/binaryinputstream;1"].createInstance(Components.interfaces.nsIBinaryInputStream);             
                bis.setInputStream(inputStream);
                
                //DBG: return stream instead of object
                return bis;        
                source = bis.readBytes(bis.available());
                bis.close();
                // patch finish
                inputStream.close();
            }                
        }
        return null;
    },
    saveToFile:function (aFilePath, aBinaryData) {
        var aFile = Components.classes["@mozilla.org/file/local;1"]
                              .createInstance(Components.interfaces.nsILocalFile);
        
        aFile.initWithPath( aFilePath );
        aFile.createUnique( Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 600);
                    
        var stream = Components.classes["@mozilla.org/network/safe-file-output-stream;1"]
                               .createInstance(Components.interfaces.nsIFileOutputStream);
        stream.init(aFile, 0x04 | 0x08 | 0x20, 0600, 0); // write, create, truncate
                    
        stream.write(aBinaryData, aBinaryData.length);
        if (stream instanceof Components.interfaces.nsISafeOutputStream) {
            stream.finish();
        } else {
            stream.close();
        }        
    },
    hashString:function (aString) {
        var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].
            createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
        converter.charset = "UTF-8";
        var result = {}; //output param
        // data is an array of bytes
        const data = converter.convertToByteArray(aString, result);
        var ch = Components.classes["@mozilla.org/security/hash;1"]
            .createInstance(Components.interfaces.nsICryptoHash);
        ch.init(ch.MD5);
        ch.update(data, data.length);
        var hash = ch.finish(false);
        
        function toHex(charCode) {
          return ("0" + charCode.toString(16)).slice(-2);
        }
        
        var s="";
        for (var i in hash) {
            s+=toHex(hash.charCodeAt(i));
        }
        return s
    },
    //returns canvas
    image2canvas:function (aHTMLImage) {
        const width=aHTMLImage.width;
        const height=aHTMLImage.height;
//        var doc =  aHTMLImage.ownerDocument;
        var doc =  document;
        var canvas = doc.createElementNS("http://www.w3.org/1999/xhtml", "canvas");
        canvas.id = 'webvisum_canvas';
        canvas.style.width = width + "px";
        canvas.style.height = height + "px";
        canvas.width = width;
        canvas.height = height;
        var ctx = canvas.getContext("2d");
        ctx.drawImage(aHTMLImage,0 ,0, width, height);
        return canvas
    },
    canvas2dataurl:function (aCanvas) {
        const io = Components.classes["@mozilla.org/network/io-service;1"]
                             .getService(Components.interfaces.nsIIOService);
        return aCanvas.toDataURL("image/png", "");
    },
    canvas2uri:function (aCanvas) {
        const io = Components.classes["@mozilla.org/network/io-service;1"]
                             .getService(Components.interfaces.nsIIOService);
        var dataUrl = this.canvas2dataurl(aCanvas);
        return io.newURI(dataUrl, "UTF8", null);
    },
    canvas2file:function(aCanvas, aDestFile) {
      // convert string filepath to an nsIFile
      var file = Components.classes["@mozilla.org/file/local;1"]
                           .createInstance(Components.interfaces.nsILocalFile);
      file.initWithPath(aDestFile);
    
      // create a data url from the canvas and then create URIs of the source and targets  
      var io = Components.classes["@mozilla.org/network/io-service;1"]
                         .getService(Components.interfaces.nsIIOService);
      var source = this.canvas2uri(aCanvas);
      var target = io.newFileURI(file)
        
      // prepare to save the canvas data
      var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
                              .createInstance(Components.interfaces.nsIWebBrowserPersist);
      
      persist.persistFlags = Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
      persist.persistFlags |= Components.interfaces.nsIWebBrowserPersist.PERSIST_FLAGS_AUTODETECT_APPLY_CONVERSION;
      
      // displays a download dialog (remove these 3 lines for silent download)
      var xfer = Components.classes["@mozilla.org/transfer;1"]
                           .createInstance(Components.interfaces.nsITransfer);
      xfer.init(source, target, "", null, null, null, persist);
      persist.progressListener = xfer;
      
      // save the canvas data to the file
      persist.saveURI(source, null, null, null, null, file);
    },   
    
    savePassword:function (password) {
      //https://developer.mozilla.org/en/XPCOM_Interface_Reference/Using_nsILoginManager
      var loginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
      var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");
      var loginInfo = new nsLoginInfo('chrome://webvisum', null, 'Registration', 'webvisum-username', password, '', '');
      
      if (Webvisum.Monkey.isMasterPasswordRequired() && !Webvisum.Monkey.enterMasterPassword()){
        return false;
      }
      else {
        Webvisum.Monkey.removePassword();
        loginManager.addLogin(loginInfo);
        return true;
      }
    },
    
    //remove the saved password from the password manager
    removePassword: function(){
      try {
         // Get Login Manager 
         var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
       
         // Find users for this extension 
         var logins = passwordManager.findLogins({}, 'chrome://webvisum', null, 'Registration');
            
         for (var i = 0; i < logins.length; i++) {
            if (logins[i].username == 'webvisum-username') {
               passwordManager.removeLogin(logins[i]);
               break;
            }
         }
      }
      catch(ex) {
         // This will only happen if there is no nsILoginManager component class, or if the user 
         //refuses to enter their master password?
      }
    },
    
    isMasterPasswordRequired: function(){
      var secmodDB = Components.classes["@mozilla.org/security/pkcs11moduledb;1"].getService(Components.interfaces.nsIPKCS11ModuleDB);
      var slot = secmodDB.findSlotByName("");
      return (slot && slot.status == Components.interfaces.nsIPKCS11Slot.SLOT_NOT_LOGGED_IN);
    },
    
    enterMasterPassword: function(){
      try {
        var decoderRing = Components.classes["@mozilla.org/security/sdr;1"].getService(Components.interfaces.nsISecretDecoderRing);
        decoderRing.encryptString("dummy");
        return true;
      }
      catch(e){
        return false;
      }
    },

    loadPassword: function(silent){
      
      var myLoginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
      //note myLoginManager.findLogins() will open an "enter master password" prompt if the user has a master password set, and has not yet entered it.
      if (silent && Webvisum.Monkey.isMasterPasswordRequired()){
        return '';
      }
      
      try {
        var logins = myLoginManager.findLogins({}, 'chrome://webvisum', null, 'Registration');

        // Find user from returned array of nsILoginInfo objects
        for(var i = 0; i < logins.length; i++){
          if (logins[i].username == 'webvisum-username'){
            return logins[i].password;
          }
        }
        //no password saved
        return '';
      }
      catch(e){
        //user refuses to enter their master password
        return '';
      }
    },
    
    
    createUri:function (aUriString, aBaseUri) {
        const io = Components.classes["@mozilla.org/network/io-service;1"] .getService(Components.interfaces.nsIIOService);
        return io.newURI(aUriString, "UTF8", aBaseUri)
    },
    
    // Heuristic for finding captcha images in  the given document (and all contained frames)
    // aDocument to analyze
    // optRulesList list of rules [{pattern:'captcha', weight:1}, ];
    // returns a list of weight-sorted image information [ImgProto]
    findCaptchas:function (aRules, aRootDocument) {
        Webvisum.Common.log("Captcha rules:"+aRules);
        const rules = aRules.rules;
        const min_weight = aRules.min_weight;
        const ImgConstr = {
            widthMin: 5,
            widthMax: 800,
            heightMin: 5,
            heightMax:600,
            minArea: 17 * 17
        };
        const ImgProto = {
            points: 0,
            rules: '',
            src:'',
            width:0,
            height:0,
            target: null,
            doc: null,
            toString:function () {
                return '(score:'+this.points+') '+this.src+' ['+this.width+'x'+this.height +'] rules:' + 
                     this.rules+' target:'+(this.target ? this.target.nodeName : 'n/a')+ ' doc:'+this.doc.location;
            }
        };
        
        //return TRUE if image fulfills the minimum image heuristic tests
        function checkCaptchaDimentions(img){
          return (img.width >= ImgConstr.widthMin 
            && img.width <= ImgConstr.widthMax 
            && img.height >= ImgConstr.heightMin 
            && img.height <= ImgConstr.heightMax
            && (img.width * img.height > ImgConstr.minArea))
        }
        
        var candidates = [];
        
        var allDocuments = this.collectDocuments(aRootDocument);
        
        for (var docIdx = 0; docIdx < allDocuments.length; docIdx++) {
            var doc = allDocuments[docIdx]; //legacy:unwrap
            Webvisum.Common.log("Searching in document: "+doc.location);
        
            // 1. The page must include a form. 
            if (doc.forms.length == 0 ) continue;
            Webvisum.Common.log('trying '+doc.forms.length+' forms');
            for (var formidx = 0; formidx < doc.forms.length; formidx++) {
                var form = doc.forms[formidx];           
                // 2. That form must have at least one text input.
                const inputs = Webvisum.Common.tags('input',form);
                Webvisum.Common.log('verifying '+ inputs.length +' inputs');
                var pass = false;
                for (var i = 0; i < inputs.length; i++) {
                    if (inputs[i].type == 'text' || inputs[i].type == 'hidden'){
                        pass = true;
                        break;
                    }
                }
                if (!pass) continue; // no textbox try another form
                Webvisum.Common.log('searching imgs');
                
                // 3. find content of all images
                var realImages = Webvisum.Common.tags('img', form); 
                Webvisum.Common.log('found '+realImages.length+' imgs');
                for (var i = 0; i < realImages.length; i++) {
                    var imgReal = realImages[i];
                    var xmlser = new XMLSerializer();
                    var imgContent = xmlser.serializeToString(imgReal);
                    try{
                        Webvisum.Common.log(i+". content='"+imgContent+"' url="+imgReal.src);
                        // 4. check image dimenstions  
                        if (checkCaptchaDimentions(imgReal)){
                             Webvisum.Common.log('dimensions test ok');
                            //5. Apply rules - and compute cumulative ranking
                            var imgInfo = Webvisum.beget(ImgProto);
                            imgInfo.target = imgReal;
                            imgInfo.doc = doc;
                            imgInfo.width = imgReal.width;
                            imgInfo.height = imgReal.height;
                            
                            imgInfo.src = imgReal.src;
                            for (var ruleIdx = 0; ruleIdx < rules.length; ruleIdx++) {
                                // Webvisum.Common.log('Rule '+ruleIdx+ " "+Webvisum.Common.dumpObj(rules[ruleIdx]) );
                                if (new RegExp(rules[ruleIdx].pattern, 'img').test(imgContent)){
                                    imgInfo.points += rules[ruleIdx].weight;
                                    imgInfo.rules += "("+ruleIdx+"="+rules[ruleIdx].weight+")";
                                }
                            }
                            Webvisum.Common.log('evaluated IMG:'+imgInfo);
                            if (imgInfo.points>=min_weight) candidates.push(imgInfo);
                            else Webvisum.Common.log("Image under treshold "+min_weight+ "  "+imgInfo);
                        }
                        else Webvisum.Common.log("Dimension check failed "+imgReal.width+'x'+imgReal.height);
                    }
                    catch(e){                        
                        Webvisum.Common.logErr('Could not examine image '+(imgReal ? imgReal.src : null) ,e);
                    }
                } //imgs
            } //forms
        } //docs
        //sort results descending
        candidates = candidates.sort(function(a,b){return -1*(a.points -b.points)})
        
        Webvisum.Common.log(candidates.length+' candidates:');
        for (var ci = 0; ci < candidates.length; ci++) {
            Webvisum.Common.log('candidate:'+candidates[ci].toString());            
        }
        
        if (candidates.length==0){
            candidates = this.findCaptchas2(aRules, aRootDocument);
        }
        
        return candidates
    },
    
    findCaptchas2:function (aRules, aRootDocument) {
        Webvisum.Common.log("Alternative captcha rules:"+aRules);
        const rules = aRules.rules;
        const min_weight = aRules.min_weight;
        const ImgConstr = {
            widthMin: 60,
            widthMax: 400,
            heightMin: 20,
            heightMax: 200,
            aspectMin: 1.75,
            aspectMax: 6
        };
        const ImgProto = {
            points: 0,
            rules: '',
            src:'',
            width:0,
            height:0,
            target: null,
            doc: null,
            toString:function () {
                return '(score:'+this.points+') '+this.src+' ['+this.width+'x'+this.height +'] rules:' + 
                     this.rules+' target:'+this.target+ ' doc:'+this.doc.location;
            }
        };
        var candidates = [];
        
        var allDocuments = this.collectDocuments(aRootDocument);
        for (var docIdx = 0; docIdx < allDocuments.length; docIdx++) {
            var doc = allDocuments[docIdx]; //legacy:unwrap
            Webvisum.Common.log("Searching in document: "+doc.location);
                 
            // 2. That doc must have at least one text input.
                const inputs = Webvisum.Common.tags('input',doc);
                Webvisum.Common.log('verifying '+ inputs.length +' inputs');
                var pass = false;
                for (var i = 0; i < inputs.length; i++) {
                    if (inputs[i].type == 'text') {
                        pass = true;
                        break;
                    }
                }
                if (!pass) continue; // no textbox try another form
                Webvisum.Common.log('searching imgs');
                
                // 3. find content of all images
                var realImages = doc.images; 
                Webvisum.Common.log('found '+realImages.length+' imgs');
                for (var i = 0; i < realImages.length; i++) {
                    var imgReal = realImages[i];
                    var xmlser = new XMLSerializer();
                    var imgContent = xmlser.serializeToString(imgReal);
                    try{
                        Webvisum.Common.log(i+". content='"+imgContent+"' url="+imgReal.src);
                        // 4. check image dimenstions 
                        var aspect = imgReal.width / imgReal.height;
                        if (imgReal.width>=ImgConstr.widthMin && imgReal.width<=ImgConstr.widthMax &&
                            imgReal.height>=ImgConstr.heightMin && imgReal.height<=ImgConstr.heightMax &&
                            aspect>=ImgConstr.aspectMin && aspect<=ImgConstr.aspectMax){
                             Webvisum.Common.log('dimensions test ok');
                            //5. Apply rules - and compute cumulative ranking
                            var imgInfo = Webvisum.beget(ImgProto);
                            imgInfo.target = imgReal;
                            imgInfo.doc = doc;
                            imgInfo.width = imgReal.width;
                            imgInfo.height = imgReal.height;
                            
                            imgInfo.src = imgReal.src;
                            for (var ruleIdx = 0; ruleIdx < rules.length; ruleIdx++) {
                                // Webvisum.Common.log('Rule '+ruleIdx+ " "+Webvisum.Common.dumpObj(rules[ruleIdx]) );
                                if (new RegExp(rules[ruleIdx].pattern, 'img').test(imgContent)){
                                    imgInfo.points += rules[ruleIdx].weight;
                                    imgInfo.rules += "("+ruleIdx+"="+rules[ruleIdx].weight+")";
                                }
                            }
                            Webvisum.Common.log('evaluated IMG:'+imgInfo);
                            if (imgInfo.points>=min_weight) candidates.push(imgInfo);
                            else Webvisum.Common.log("Image under treshold "+min_weight+ "  "+imgInfo);
                        }
                        else Webvisum.Common.log("Dimension check failed "+imgReal.width+'x'+imgReal.height);
                    }
                    catch(e){
                        Webvisum.Common.logErr('Could not examine image '+(imgReal ? imgReal.src : null) ,e);
                    }
                } //imgs
        } //docs
        
        //sort results descending
        candidates = candidates.sort(function(a,b){return -1*(a.points - b.points)})
        
        
        Webvisum.Common.log(candidates.length+' alternative candidates:'+candidates);
        
        //thick front ?
        if (candidates.length>1){
            if (candidates[0].points - candidates[1].points == 0) return [];            
        }
        return candidates
    },



    html: function(nodes, parentNode){
        var doc = parentNode ? parentNode.ownerDocument : document;
        if (!Webvisum.Monkey.isArray(nodes)){
            nodes = [nodes];
        }        
        for (var i = 0; i < nodes.length; i++) {
            var nodeInfo = nodes[i];
            //text node
            if (typeof(nodeInfo) === "string"){
                parentNode.appendChild(doc.createTextNode(nodeInfo));
            }
            //element
            else {
                for(var tagName in nodeInfo){
                    var tag = doc.createElement(tagName);
                    var attrs = nodeInfo[tagName];
                    for(var attrName in attrs){
                        //special case #children
                        if (attrName === "#text"){
                            tag.appendChild(doc.createTextNode(attrs[attrName]));
                        }
                        //special case, child nodes
                        else if (attrName === "#children"){
                            Webvisum.Monkey.html(attrs[attrName], tag);
                        }
                        //"normal" attributes
                        else if (attrs[attrName] !== null){
                            tag.setAttribute(attrName, ""+ attrs[attrName]); 
                        }
                        else {
                            //null attributes should be ignored
                        }
                    }
                    parentNode.appendChild(tag);
                }
            }
        }
    },

    isArray: function(obj){
        return (Object.prototype.toString.call(obj) === '[object Array]');
    }  
    
}