// REQUIRES: common.js



Webvisum.Sound = {
    sounds: {},
    muted: {},
    events: {
        error:true,
        click:true
    },
    init:function () {
        this.player = Components.classes["@mozilla.org/sound;1"].createInstance(Components.interfaces.nsISound);
        this.player.init();
        this.sounds = {};
        this.muted = {};
        return this;
    },
    shutdown:function () {
        Webvisum.Common.log("unloading sounds")
        this.player = null;
        this.sounds = {};
        this.muted = {};
    },
    mute:function (aSoundName, aBoolean) {
        Webvisum.Common.log("Sound '" + aSoundName + "' muted:" +aBoolean);
        this.muted[aSoundName] = aBoolean;   
    },
    muteAll:function () {
        for (var soundId in this.sounds){
            this.mute(soundId, true);
        }
    },
    setSound:function (aName, aUrlString) {
        Webvisum.Common.log("loading sound "+aName+" to "+aUrlString);                
        var url = this._toUrl(aUrlString);
        this.sounds[aName]=url;        
    },
    play:function (aSoundName) {
        var soundUrl = this.sounds[aSoundName];
        if (this.muted[aSoundName]) return;
        if (!soundUrl) throw "Sound not defined:"+aSoundName;
        this.player.play(soundUrl);
        Webvisum.Common.log('Played sound: '+aSoundName);   
    },
    playStringUrl:function (aUrlString) {
        var url = this._toUrl(aUrlString);
        this.player.play(url);
    },
    _toUrl:function (aUrlOrPathString) {
        const ios = Components.classes['@mozilla.org/network/io-service;1'].getService(Components.interfaces.nsIIOService);
        try {
            return ios.newFileURI(aUrlOrPathString);
        }
        catch (e) {
            try {
                return ios.newURI(aUrlOrPathString, null, null);
            }
            catch (e1){
//                throw "Incorrect sound file path/url '"+aUrlOrPathString+"'";
//                alert("Incorrect sound file path/url '"+aUrlOrPathString+"'");
                return null;
            }
        }
    },
    playDefault:function() {
        this.play('click');
    }
}