// REQIURES: common.js



Webvisum.State = {
    states:{ok:true,connect:false,disabled:true,error:false,offline:true},
    errors:new Array(),
    _session_key:null,
    serverMessages:new Array(),
    listeners: [],    
    isLogged:function () {
        return this.session_key != null;
    },
    get session_key(){
        return this._session_key;
    },
    set session_key(aKey){
        if (aKey && aKey.length>0){
            this._session_key = aKey;
            this.setState('offline', false);
        }
        else {
            this._session_key = null;
            this.setState('offline', true);
        }
    },
    setState:function (aState, aBool) {
        if (aState in this.states){
            this.states[aState] = aBool;
            this._dispatch(aState);
            //this.updateGlobalState();
        } 
        else throw "Invalid status: "+aState        
    },
    getGlobalState:function() {
        var status = 'ok';
        if (this.states['disabled']) status = 'disabled';
        else if (this.states['error']) status = 'error';
        else if (this.states['connect']) status = 'connect';
        else if (this.states['offline']) status = 'offline';
        else status = 'ok';
        return status;
        
    },
    // callback function(changedStateName, theStateKeeper)
    addListener:function (aCallback) {
        this.listeners.push(aCallback);
    },
    removeListener:function (aCallback) {
        const idx = this.listeners.indexOf(aCallback);
        if (idx>=0) {
            this.listeners.splice(idx, 1);
            return true;
        }
        return false
    },
    _dispatch:function (aChange, optPayload) {
        for (var i = 0 ; i < this.listeners.length; i++) {
            try {
                this.listeners[i](aChange, this, optPayload);
            }
            catch (e){
                Webvisum.Common.logErr("Error in state listener", e);
            }
        }
    },
    pushServerMsg:function (aMsg) {
        this.serverMessages.push(aMsg);
        this._dispatch('msg.server', aMsg);
    },
    addError:function (aMsg, anExc) {
        this.errors.push(aMsg);
        this.setState('error', true);
        this._dispatch('msg.error', aMsg);
    },
    cleanErrors:function () {
        this.errors=new Array();
        this.setState('error', false);
    },
    getErrors:function() {
        return this.errors;
    },
    errorsAsString:function() {
        var msg='';
        for (var i = 0; i < this.errors.length; i++) {
            msg+=i+". "+this.errors[i]+"; ";
        }
        return msg;
    }    
}