//REQUIRES: common.js



Webvisum.UrlFilter = {
    whiterules:[],
    blackrules:[],
    isAllowed:function (aString) {
        var result = false;
        for (var i = 0; i < this.whiterules.length; i++) {
            var rule  = this.whiterules[i];
            if (rule.test(aString)) {
                result = true;
                break;
            }
        }
        if (!result) return result;
        for (var i = 0; i < this.blackrules.length; i++) {
            var rule  = this.blackrules[i];
            if (rule.test(aString)) return false;
        }
        return true;
    },
    setRules:function (aWhileListString, aBlackListString) {
        if (aWhileListString!=null){
            this.whiterules = this.parse(aWhileListString);
        }
        if (aBlackListString!=null){
            this.blackrules = this.parse(aBlackListString);
        }
    },
    parse:function (aRulesListString) {
        var rules = [];
        const lines = aRulesListString.split("\n");
        for (var i = 0; i < lines.length; i++) {
            var line = Webvisum.Common.trim(lines[i]);
            try{
                if (line.length>0) {
                    rules.push(new RegExp(line));
                }
            }
            catch (e){
                Webvisum.Common.logErr("Error parsing filter rule:"+line, e);
            }
        }
        return rules;
    }
}
