// REQUIRE: common.js



Webvisum.Visuals = {
    enabledStyles: {
//        underline: true,  //TEST     
//        highlight: true  //TEST     
    },
    styles : {
        underline: 'chrome://webvisum/content/css/underline.css',
        hide_images: 'chrome://webvisum/content/css/hide_images.css',
        hide_flash: 'chrome://webvisum/content/css/hide_flash.css',
        highlight: 'chrome://webvisum/content/css/highlight.css',
        focus: 'chrome://webvisum/content/css/focus.css',
        nosound: 'chrome://webvisum/content/css/nosound.css',
        contrast_1: 'chrome://webvisum/content/css/contrast_1.css'
    },
    documents: [],
    //set initial styles
    initStyles:function (aStyleHash) {
        for (var styleId in aStyleHash){
            if (aStyleHash[styleId]) this.enableStyle(styleId);
            else this.disableStyle(styleId);
        }
    },
    disableAllStyles:function () {
        Webvisum.Common.log('disabling all styles');
        for (var styleId in this.enabledStyles){
            this.disableStyle(styleId);
        }
    },
    // to enable new style
    enableStyle:function (aStyleId) {
        Webvisum.Common.log('enabling '+aStyleId+", documents:"+this.documents.length);
        if (!(aStyleId in this.enabledStyles)) {
            this.enabledStyles[aStyleId]=true;
            for (var i = 0; i < this.documents.length; i++) {
                this.addStyle(aStyleId, this.documents[i]);
            }
        }     
    },
    //to disable a new style
    disableStyle:function (aStyleId) {
        Webvisum.Common.log('disabling '+aStyleId+", documents:"+this.documents.length);
        if (aStyleId in this.enabledStyles) {
            delete this.enabledStyles[aStyleId];
            for (var i = 0; i < this.documents.length; i++) {
                this.removeStyle(aStyleId, this.documents[i]);
            }
        }
    },
    // on new document
    addDocument:function (aDocument) {
        Webvisum.Common.log('Visuals: adding document '+aDocument.location+' enabled:'+Webvisum.Common.dumpObj(this.enabledStyles));
        this.documents.push(aDocument);
        for (var id in this.enabledStyles){
            this.addStyle(id, aDocument);
        }
    },
    removeDocument:function (aDocument, optIdxHelper) {
        Webvisum.Common.log('Visual: removing styles from '+aDocument.location);
        const idx = (optIdxHelper !=null) ? optIdxHelper : this.documents.indexOf(aDocument);
        if (idx>=0){
            var doc = this.documents.splice(idx,1)[0];            
            for (var id in this.enabledStyles){
                this.removeStyle(id, doc);
            }
        }
    },
    removeAllDocuments:function (optJustTheseDocs) {
        const docs = optJustTheseDocs ? optJustTheseDocs : this.documents; 
        for (var i = 0; i < docs.length; i++) {
            var doc = docs[0];
            this.removeDocument(doc, 0);           
        }
    },
    addStyle:function (aStyleId, aDocument) {
//            Webvisum.Common.log('ADD '+aStyleId);
            var linkEl  = aDocument.createElement("link");
            linkEl.setAttribute("href", this.styles[aStyleId]);
            linkEl.setAttribute("id", aStyleId);
            linkEl.setAttribute("rel", "stylesheet");
            linkEl.setAttribute("type", "text/css");
            Webvisum.Common.tag('head', aDocument).appendChild(linkEl);
    },
    removeStyle:function (aStyleId, aDocument) {
            Webvisum.Common.log("REMOVE '"+aStyleId + "' from "+aDocument);
            var linkEl = Webvisum.Common.idd(aStyleId, aDocument);
            if (linkEl) linkEl.parentNode.removeChild(linkEl);
    }
}
