// === Note to AMO Reviewer ===
//
// this file raises a "JavaScript namespace pollution" warning when checked by the automated addon 
// validator at AMO. AFAICT the code is taken directly from the example code at https://developer.mozilla.org/en/How_to_Build_an_XPCOM_Component_in_Javascript
// I'm no component developer, and I'm not confident changing how any of this works given how much "magic" happens
// with XPCOM. If the "JavaScript namespace pollution" is still a problem then _please_ point me to a good code example
// which I can learn from.
// thanks,
// Karl (karl.dearden@gmail.com)



Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

function WebvisumService() {
    this.wrappedJSObject = this;
}

const CLASS_NAME = "WebvisumService";
const CONTRACT_ID = "@webvisum/webvisumservice;1";
const CLASS_ID = Components.ID("b333541c-087a-44a8-ade4-c66914db4a35");

function WebvisumService() {
    this.wrappedJSObject = this;
}


WebvisumService.prototype = {
  classDescription: "Webvisum Service Javascript XPCOM Component",
  classID:          Components.ID("{b333541c-087a-44a8-ade4-c66914db4a35}"),
  contractID:       "@webvisum/webvisumservice;1",
  QueryInterface: XPCOMUtils.generateQI([Components.interfaces.nsIWebvisumService]),
  hello: function() { return "Hello World!"; },
  
  webvisum : null,
  global : null,
  // QueryInterface : function(anIID) {
        // // add any other interfaces you support here
        // if (!anIID.equals(Components.interfaces.nsISupports))
            // throw Components.results.NS_ERROR_NO_INTERFACE;
        // return this;
    // },
  ping : function() {
      return "pong";
  }
};


// Factory
var WebvisumServiceFactory = {
    singleton : null,
    createInstance : function(aOuter, anIID) {
        if (aOuter != null)
            throw Components.results.NS_ERROR_NO_AGGREGATION;
        if (this.singleton == null)
            this.singleton = new WebvisumService();
        return this.singleton.QueryInterface(anIID);
    }
};

// Module
var WebvisumServiceModule = {
    registerSelf : function(aCompMgr, aFileSpec, aLocation, aType) {
        aCompMgr = aCompMgr
                .QueryInterface(Components.interfaces.nsIComponentRegistrar);
        aCompMgr.registerFactoryLocation(CLASS_ID, CLASS_NAME, CONTRACT_ID,
                aFileSpec, aLocation, aType);
    },

    unregisterSelf : function(aCompMgr, aLocation, aType) {
        aCompMgr = aCompMgr
                .QueryInterface(Components.interfaces.nsIComponentRegistrar);
        aCompMgr.unregisterFactoryLocation(CLASS_ID, aLocation);
    },

    getClassObject : function(aCompMgr, aCID, anIID) {
        if (!anIID.equals(Components.interfaces.nsIFactory))
            throw Components.results.NS_ERROR_NOT_IMPLEMENTED;

        if (aCID.equals(CLASS_ID))
            return WebvisumServiceFactory;

        throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    canUnload : function(aCompMgr) {
        return true;
    }
};


var components = [WebvisumService];
function NSGetModule(compMgr, fileSpec) {
  return XPCOMUtils.generateModule(components);
}


/**
* XPCOMUtils.generateNSGetFactory was introduced in Mozilla 2 (Firefox 4).
* XPCOMUtils.generateNSGetModule is for Mozilla 1.9.2 (Firefox 3.6).
*/
if (XPCOMUtils.generateNSGetFactory){
  var NSGetFactory = XPCOMUtils.generateNSGetFactory([WebvisumService]);
}
else {
  var NSGetModule = XPCOMUtils.generateNSGetModule([WebvisumService]);
}  

// //module initialization
// function NSGetModule(aCompMgr, aFileSpec) {
    // return WebvisumServiceModule;
// }
